;; Lexicographic "less than" predicate over two sequential tables.
(fn lexico-lt? [a b]
  (fn idx [i]
    (case [(. a i) (. b i)]
      [ai bi] `(let [x# ,ai y# ,bi]
                 (or (< x# y#)
                     (and (not (< y# x#)) ,(idx (+ i 1)))))
      [nil bi] true
      _ false))
  (idx 1))

{: lexico-lt?}
